/*
 * FeRAM_CY15B108.h
 * Anschluss zweier 8MBit-FeRAMs CY15B108 an MSP430G2553
 *
 *  Created on: 20.03.2015 as FRAM_RS2MT_SPI.h  Author: DL9MWE
 *  21.04.2019
 *  15.02.2023 adaptiert fr 8MBit FeRAM CY15B108
 */

#ifndef FERAM_CY15B108_H_
#define FERAM_CY15B108_H_

#define FeRAM_maxAddr 0xFFFFF            // FeRAM-Size in Bytes 10486576

#define PORTFeRAM_CS1_PIN         BIT0   // alles an Port 2, siehe SW_SPI.h
#define PORTFeRAM_CS2_PIN         BIT2

unsigned int uiFeRAM_CY15B108_init();
unsigned int FeRAM_check_deviceID(unsigned int CS_PIN);
unsigned long ulFeRAM_CY15B108_writebytes(unsigned long addr, unsigned char *txData, unsigned int anzahl);
unsigned long ulFeRAM_CY15B108_readbytes(unsigned long addr, unsigned char *rxData, unsigned int anzahl);


#define FeRAM_WREN      0x06    // Set Write Enable Latch  0000 0110B
#define FeRAM_RDSR      0x05    // Read Status Register
#define FeRAM_WRITE     0x02    // Write Memory data  0000 0010B
#define FeRAM_READ      0x03    // Read Memory data  0000 0011B
#define FeRAM_RDID      0x9F    // Read device ID  1001 1111B
#define FeRAM_RUID      0x4C    // Read unique ID  1001 1111B

#endif /* FERAM_CY15B108_H_ */
