/*
 * SW_SPI.c
 * Software-Implementation einer SPI-Schnittstelle
 *
 *  Created on: 02.01.2015
 *      Author: DL9MWE
 *      25.07.2016
 */
#include "main.h"

// SPI - Software-Schnittstelle initialisieren
void vSPI_init(void) {
    // Port Outputs: SPI-Clock, SPI-DataOut (MOSI)
    PORT_SPI_DIR |= SPI_SCK_BIT | SPI_MOSI_BIT;
    PORT_SPI_SEL = 0;
    PORT_SPI_SEL2 = 0;              // normal IO-Function

    PORT_SPI_OUT |= SPI_MOSI_BIT;   // MOSI auf 1
    PORT_SPI_OUT &= ~SPI_SCK_BIT;   // SCK auf 0
}

// low-level write and read SPI-Byte
unsigned char ucSPI_Byte(unsigned char tx_data) {
    unsigned int bits;
    unsigned char rx_data=0;

    for (bits = 8; bits != 0; --bits) {     // loop until all 8 bits are processed, MSB first
        if (tx_data & BIT7)                 // test output bit
            PORT_SPI_OUT |= SPI_MOSI_BIT;   // MOSI = 1
        else
            PORT_SPI_OUT &= ~SPI_MOSI_BIT;  // else MOSI = 0
        rx_data <<= 1;
        if (PORT_SPI_IN & SPI_MISO_BIT)     // check input bit
            rx_data += 1;                   // MISO == 1
        PORT_SPI_OUT |= SPI_SCK_BIT;        // clock high [SCK = 1]
        tx_data <<= 1;                      // shift to next output-bit
        PORT_SPI_OUT &= ~SPI_SCK_BIT;       // clock low [SCL = 0]
    }
    return rx_data;
}

void vSPI_read_multiplebytes(unsigned int len, unsigned char *array) {
    unsigned int index=0;
    while(len--) {
        array[index++] = ucSPI_Byte(0);
    }
}

// Ende SW_SPI.c
